### Made by TIG of the sketchup forums
### Edited by Neo1471 of IMVU to allow simple use via the pluggin list
### it works on current selection

### Makes all selected instances unique and edits names...
### Copy all of this text into a text-file called something like
### it works on current selection

#-----------------------------------------------------------------------------

require 'sketchup.rb'

#-----------------------------------------------------------------------------

def helloWorld
        makeallselectedunique()
        UI.messagebox "All nodes numberd!"
        
end 

if( not file_loaded?("makeallselectedunique.rb") )
    add_separator_to_menu("Plugins")
    plugins_menu = UI.menu("Plugins")
    plugins_menu.add_item("Number Nodes [Neo1471]") { helloWorld }
end

#-----------------------------------------------------------------------------
def makeallselectedunique()
  ints=[];Sketchup.active_model.selection.each{|e|
    if e.typename=="ComponentInstance"
      e.make_unique ### make instance unique
      ints.push(e) ### keep list of these instances
    end#if
  }#end each
  ints.each{|e|name=e.definition.name
    ### name with '#nn' on end, e.g. ABC#2
    prefix=(name.split("#")-[name.split("#").last]).to_s
    prefix=name if prefix==""
    ### e.g. ABC
    suffix=name.split("#").last.to_i ### e.g. 2 as integer
    suffix=1 if suffix<1
    ### check all extg defs for possible new name
    Sketchup.active_model.definitions.each{|d|
      suffix=suffix+1 if d.name==prefix+suffix.to_s
      ### e.g. ABC2 exists so try to make it ABC3 etc
    }
    newname=prefix+suffix.to_s
    e.definition.name=newname ### renames definition
    puts name+" >>> "+newname ### put a # in front of this line to stop console printout
  }#end each
  return nil
end#def

#-----------------------------------------------------------------------------
file_loaded("makeallselectedunique.rb")



### You may modify this file but allways keep the history of who has edited
### it so all be remmemberd for there help making life easyer!
### You may not distribute this file without express permission from Neo1471 to do so
### If you wish to link to this file please link to the page on my website
### (do not leach strate from its download location.)